// ================================================================================================================================================================================================
// Title:	Reloading Support
// Author(s):	Rykuta
//
// Description:	A complete remake/overhaul to Space Guy's old ammoguns.
//              UPDATE: Also adds limited ammo into the mix, yay.
//
// Disclaimer:	This add-on is the sole property of Rykuta and his subsidiaries, any illegal reproduction of this software (AKA Pretending its your own) will result in legal action.
//					By downloading this add-on you agree to the terms of service, which are as follows: You will not take credit for this add-on. You will report
//					all glitches and problems you have with the mod. You will not alter any of the code within this document without the express written consent of
//					the  Development Team. You will not re-release this add-on on RTB or any other add-on location.
//
//			That being said, this code is for the purpose of making easy to implement ammo systems for weaponsets. Please use this for its intended purpose.
//				- Rykuta
//
// ================================================================================================================================================================================================
//
// ================================================================================================================================================================================================
// Table of Contents:
// ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// Section 1:	Variables & RTB .......	# 29 
// Section 2:	Main Package ..........	# 35 
// Section 2.5:	Image Stuff ...........	# 106 
// Section 3:   Useful Functions ...... # ?
// ================================================================================================================================================================================================
// =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
// 
// ================================================================================================================================================================================================
// Section 1:	Varaibles & RTB </3
// ================================================================================================================================================================================================
if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::Hooks::ServerControl)	exec("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs");
	RTB_registerPref("Enable Reload","Ry-Guns","Pref::RYG::ReloadingEnabled","bool","Support_RyGuns",1,0,0);    // Possibly Functions as intended.
	RTB_registerPref("Disable Dryfire","Ry-Guns","Pref::RYG::AutoReload","bool","Support_RyGuns",0,0,0);        
	RTB_registerPref("Chambered Bullet","Ry-Guns","Pref::RYG::ExtraBullet","bool","Support_RyGuns",1,0,0);
	RTB_registerPref("Limited Ammo","Ry-Guns","Pref::RYG::LimitedAmmo","bool","Support_RyGuns",1,0,0); // THIS FEATURE IS CURRENTLY MESSING WITH ME AND NOT WORKING.
}
else
{
	$Pref::RYG::ReloadingEnabled = 1;	// Do the guns reload?
	$Pref::RYG::ExtraBullet = 1;		// Add an extra bullet on reload? (EG: 26/35 goes to 36/35 bullets)
    $Pref::RYG::AutoReload = 0;         // Guns they don't reload automatically
	$Pref::RYG::LimitedAmmo = 0;        // Do the guns have a restriction on bullets?
}
// ================================================================================================================================================================================================
// Section 2:	Main Package
// ================================================================================================================================================================================================
package RYGReloading	
{
    // Currently Torque does not have any effecient garbage cleaning methods that I am aware of, so dropping your weapon and picking up another weapon of the same type, will not alter ammo count.
    // This, although unintended, works better than it simply returning to max, so for now, deal with it. This is something I am working on activly.

    // Handle the varaible exchange when gun is picked up. (Oddly useless function is oddly useless)
	function Player::pickup(%this,%item)
	{
		%data = %item.dataBlock;
		%ammo = %item.weaponAmmoLoaded;
		%val = Parent::pickup(%this,%item);
		if(%val == 1 && %data.RYG_ClipSize > 0 && isObject(%this.client))
		{
			%slot = -1;
			for(%i=0;%i<%this.dataBlock.maxTools;%i++)
			{
				if(isObject(%this.tool[%i]) && %this.tool[%i].getID() == %data.getID() && %this.toolAmmo[%i] $= "")
				{
					%slot = %i;
					break;
				}
			}
			
			if(%slot == -1)
				return %val;
			
			if(%ammo $= "")
			{
				%this.clipAmmo[%this.tool[%slot].Image] = %data.RYG_ClipSize;
			}
			else
			{
				%this.clipAmmo[%this.tool[%slot].Image] = %ammo;
			}
		}
		return %val;
	}
	
	function ItemData::onAdd(%this,%obj)
	{
		if($weaponAmmoLoaded !$= "")
		{
			%obj.weaponAmmoLoaded = $weaponAmmoLoaded;
			$weaponAmmoLoaded = "";
		}
		Parent::onAdd(%this,%obj);
	}
	
	function servercmdDropTool(%client,%slot)
	{
		if(!isObject(%client.player))
			return Parent::servercmdDropTool(%client,%slot);
		
		if(!isObject(%client.player.tool[%slot]) || %client.player.tool[%slot].RYG_ClipSize <= 0)
			return Parent::servercmdDropTool(%client,%slot);
		
		$weaponAmmoLoaded = %client.player.clipAmmo[%client.player.tool[%slot].Image];
		%client.player.clipAmmo[%client.player.tool[%slot].Image] = "";
		return Parent::servercmdDropTool(%client,%slot);
	}
	
	// Tell the Gun to Reload.
	function servercmdLight(%client)
	{
		// Is dat player alive? And is there gun existant?
		if(isObject(%client.player) && isObject(%client.player.getMountedImage(0)))
		{
			%p = %client.player;
			%im = %p.getMountedImage(0);
			if(canReload(%client, %p, %im) > 0 && $Pref::RYG::ReloadingEnabled == 1)
			{
				%p.setImageAmmo(0,0);
				return;
			}
		}
		Parent::servercmdLight(%client);
	}
	
	function WeaponImage::OnMount(%this, %obj, %slot)
	{
		if(%obj.clipAmmo[%this] $= "" && %this.RYG_Support == 1)
			%obj.clipAmmo[%this] = %this.Item.RYG_ClipSize; 
		else if(%obj.clipAmmo[%this] < 0 && this.RYG_Support == 1)
			%obj.clipAmmo[%this] = 0; 	
		
		// Limited Ammo stuff
        if(%this.Item.RYG_AmmoType $= "")
        {
            %val = %this;
            %maxAmmo = %this.Item.RYG_MaxAmmo;
        }
        else
        {
            %val = %this.Item.RYG_AmmoType;
            %maxAmmo = $RYGMaxAmmo[%val];
        }
    
        if(%obj.gunAmmo[%val] $= "" && %this.RYG_Support == 1)
            %obj.gunAmmo[%val] = %maxAmmo;
		
		if(%this.RYG_Support == 1)
			displayAmmo(%obj, %this);
			
		parent::OnMount(%this, %obj, %slot);
	}
	
    // ===========================================================================================================================================================================================
    // Section 2.5:	Image Stuff
    // ============================================================================================================================================================================================
    // Here we have all of the weaponImage state stuff, feel free to make your own functions if these do not suit your needs.

	//Check if the gun needs to reload. Use this to trigger state changes.
	function WeaponImage::onLoadCheck(%this,%obj,%slot)
	{
		if(%obj.clipAmmo[%this] <= 0 && %this.item.RYG_ClipSize > 0 && %obj.getState() !$= "Dead")
			%obj.setImageAmmo(%slot,0);
		else
			%obj.setImageAmmo(%slot,1);
	}
	
	//Use this state in single-ammo reload weapons e.g. Shotgun, Scattergun
	function WeaponImage::onReloadCheck(%this,%obj,%slot)
	{
		if(%obj.clipAmmo[%this] < %this.item.RYG_ClipSize && %this.item.RYG_ClipSize > 0 && %obj.getState() !$= "Dead")
			%obj.setImageAmmo(%slot,0);
		else
			%obj.setImageAmmo(%slot,1);
	}
	
	// WeaponImage Stuff
	function WeaponImage::OnClipRemoved(%this, %obj, %slot)
	{
		%obj.playThread(2, shiftright);
		%obj.schedule(150, playThread, 2, activate);
		serverPlay3D(%this.RYG_ClipOutSound,%obj.getPosition());
		displayAmmo(%obj, %obj.getMountedImage(0));
	}

	function WeaponImage::OnClipInserted(%this, %obj, %slot)
	{
		%obj.playThread(2, shiftright);
		%obj.schedule(100, playThread, 2, plant);
		serverPlay3D(%this.RYG_ClipInSound,%obj.getPosition());
		displayAmmo(%obj, %obj.getMountedImage(0));
	}

	function WeaponImage::OnGunBolt(%this, %obj, %slot)
	{
		%obj.playThread(2, shiftleft);
		serverPlay3D(%this.RYG_BoltSound,%obj.getPosition());
		displayAmmo(%obj, %this);
	}
	
	function WeaponImage::NoRoundsLeft(%this,%obj,%slot)
	{
		%obj.setImageAmmo(%slot,1);
	}
	
	function WeaponImage::BlankFire(%this,%obj,%slot)
	{
        if(%im.Item.RYG_AmmoType $= "")
            %val = %this;
        else
            %val = %im.Item.RYG_AmmoType;

		if($Pref::RYG::AutoReload || ($Pref::RYG::LimitedAmmo == 1 && %obj.gunAmmo[%val] > 0))
			return serverCmdLight(%obj.client);
		%obj.playThread(2, plant);
		serverPlay3D(ClipEmptySound,%obj.getPosition());
	}
	
	// Ammunition Junk (Clip Stuff)
	function WeaponImage::OnGunReloadFinished(%this, %obj, %slot)
	{	
		%ammoSpent = %this.Item.RYG_ClipSize - %obj.clipAmmo[%this];
		%obj.clipAmmo[%this] = %this.Item.RYG_ClipSize;
		
		if($Pref::RYG::ExtraBullet == 1 && %ammoSpent < %this.Item.RYG_ClipSize && %this.Item.RYG_NoExtraBullet != 1)
			%obj.clipAmmo[%this]++;
		
		%obj.setImageAmmo(%slot, 1);
		displayAmmo(%obj, %this);
		removeAllRecoil(%this);
	}

	function WeaponImage::OnShottyReloaded(%this, %obj, %slot)
	{
		%obj.clipAmmo[%this]++;
		displayAmmo(%obj, %this);
		%obj.setImageAmmo(%slot, 1);
		removeAllRecoil(%this);
	}
	
	function WeaponImage::OnShotgunPump(%this, %obj, %slot)
	{
		%obj.playThread(2, shiftleft);
		%obj.schedule(250, playThread, 2, plant);
		displayAmmo(%obj, %this);
		serverPlay3D(%this.RYG_BoltSound, %obj.getPosition());
	}
	
	function WeaponImage::OnRoundInserted(%this, %obj, %slot)
	{
		%obj.playThread(2, shiftRight);
		%obj.schedule(250, playThread, 2, plant);
		displayAmmo(%obj, %this);
		serverPlay3D(%this.RYG_ClipInSound, %obj.getPosition());
	}
	
	function WeaponImage::OnChamberOpen(%this, %obj, %slot)
	{
		%obj.playThread(2, shiftleft);
		%obj.schedule(150, playThread, 2, shiftaway);
		displayAmmo(%obj, %this);
		serverPlay3D(%this.RYG_ClipOutSound, %obj.getPosition());
	}
	
	function WeaponImage::OnChamberClosed(%this, %obj, %slot)
	{
		%obj.playThread(2, shiftRight);
		%obj.schedule(150, playThread, 2, plant);
		displayAmmo(%obj, %this);
		serverPlay3D(%this.RYG_BoltSound, %obj.getPosition());
	}
};
activatepackage(RYGReloading);

// ================================================================================================================================================================================================
// Section 3:	Useful Functions
// ================================================================================================================================================================================================

// Used in if statements checking if a gun can reload or not. (%this is client, %obj is player, %im is image.)
function canReload(%this, %obj, %im)
{
	if($Pref::RYG::ReloadingEnabled != 1)
		return 0;

    if(%im.Item.RYG_AmmoType $= "")
        %val = %this;
    else
        %val = %im.Item.RYG_AmmoType;

	if($Pref::RYG::ExtraBullet && %im.Item.RYG_NoExtraBullet != 1)
		%otherVal = 1;
	else
		%otherVal = 0;
		
	if(%im.Item.RYG_Reloads == 1 && %obj.clipAmmo[%im] < %im.Item.RYG_ClipSize + %otherVal)
    {
        if($Pref::RYG::LimitedAmmo == 1 && %obj.gunAmmo[%val] > 0)
		    return 1;
        else if($Pref::RYG::LimitedAmmo == 0)
            return 1;
		else
			return 0;
    }
	else
		return 0;
}
// Function that displays a player's item, requires %obj (Player), and %item (Object Image)
function displayAmmo(%obj, %item)
{
    // For my convenience, admittedly ineffecient.
    %this = %item;  %im = %item;
    // Limited Ammo stuff
    if(%item.Item.RYG_AmmoType $= "")
    {
        %val = %item;
        %maxAmmo = %item.Item.RYG_MaxAmmo;
    }
    else
    {
        %val = %item.Item.RYG_AmmoType;
        %maxAmmo = $RYGMaxAmmo[%val];
    }

	%client = %obj.client;
    if($Pref::RYG::LimitedAmmo == 1 && $Pref::RYG::ReloadingEnabled == 1)
	    commandToClient(%client,'bottomPrint',"<just:right><font:impact:24><color:fff000>Ammo: <font:impact:34>\c6" @ %obj.clipAmmo[%item] @ "/" @ %item.Item.RYG_ClipSize @ " | " @ getAmmoDisplay(%val, %maxVal), 1, 2, 3, 4);
    else if($Pref::RYG::LimitedAmmo == 1 && $Pref::RYG::ReloadingEnabled == 0)
	    commandToClient(%client,'bottomPrint',"<just:right><font:impact:24><color:fff000>Ammo: <font:impact:34>\c6" @ getAmmoDisplay(%val, %maxVal), 1, 2, 3, 4);
    else if($Pref::RYG::ReloadingEnabled == 1 && $Pref::RYG::LimitedAmmo == 0)
	    commandToClient(%client,'bottomPrint',"<just:right><font:impact:24><color:fff000>Ammo: <font:impact:34>\c6" @ %obj.clipAmmo[%item] @ "/" @ %item.Item.RYG_ClipSize @ "", 1, 2, 3, 4);
}

// %val should be the player's current ammo, and %maxval should be the highest value the ammo can reach.
// Will return a string with color and numbers.
function getAmmoDisplay(%val, %maxVal)
{
    %x = %maxVal / 100; // if maxVal was out of 100...
    %percent = %val * %x;   // then the % is the val times the factor.
    if(%percent > 75)
        %percent = "<color:00FF00>" @ %percent;
    else if (%percent > 50)
        %percent = "<color:FFFF00>" @ %percent;
    else if (%percent > 25)
        %percent = "<color:FF8800>" @ %percent;
    else if (%percent > 0)
        %percent = "<color:FF0000>" @ %percent;
    else
        %percent = "<color:660000>" @ %percent;
    %percent = %percent @ "<color:FFFFFF>%";
    return %percent;
}