// REQUIRES SUPPORT_ALTDATABLOCK BY SPACEGUY!
// ================================================================================================================================================================================================
// Title:	Bipod support.
// Author(s):	Rykuta
//
// Description:	This code allows for weapons to deploy bipods with the use of the right mouse key. Iron-sights are dumb, get over it.
//		
// Disclaimer:	This add-on is the sole property of Rykuta and his subsidiaries, any illegal reproduction of this software (AKA Pretending its your own) will result in legal action.
//					By downloading this add-on you agree to the terms of service, which are as follows: You will not take credit for this add-on. You will report
//					all glitches and problems you have with the mod. You will not alter any of the code within this document without the express written consent of
//					the  Development Team. You will not re-release this add-on on RTB or any other add-on location.
//
//			That being said, this code is for the purpose of giving weapons bipod-esk abilities, enjoy.
//				- Rykuta
//
// ================================================================================================================================================================================================
// THE ACTUAL CODE STARTS NOW
// ================================================================================================================================================================================================
datablock AudioProfile(BiPodEquipSound)
{
   filename    = "./Bipod_Deploy.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(BiPodDequipSound)
{
   filename    = "./Bipod_UnDeploy.wav";
   description = AudioClose3d;
   preload = true;
};

datablock PlayerData(NoMoveArmor : PlayerStandardArmor)
{
	uiName = "No Movement Player";
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

	showEnergyBar = false;
	runForce = 1000000; // Prevents Sliding
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 0;
   maxBackwardSpeed = 0;
   maxSideSpeed = 0;

   maxForwardCrouchSpeed = 0;
   maxBackwardCrouchSpeed = 0;
   maxSideCrouchSpeed = 0;

   jumpForce = 0; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;
};


// Start a package, cuz torque likes it when you package things.
package Bipods
{

// This function designed by ipquarx, forces placement on brick tops only.
function candeploy(%this)
{
	%range = 2;
	%obj = %this.player;
	%start = %obj.getEyePoint();
	%fvec = %obj.getForwardVector();
	%fX = getWord(%fvec,0);
	%fY = getWord(%fvec,1);
	%evec = %obj.getEyeVector();
	%eX = getWord(%evec,0);
	%eY = getWord(%evec,1);
	%eZ = getWord(%evec,2);
	%eXY = mSqrt(%eX*%eX+%eY*%eY);
	%aimVec = %fX*%eXY SPC %fY*%eXY SPC %eZ;
	%shotvec = %aimvec;
	%end = vectorAdd(%start,vectorScale(%shotVec,2));
	%ray = containerraycast(%start, %end, $TypeMasks::FxBrickAlwaysObjectType, %obj);
	%col = getWord(%ray,0);
	if(isObject(%col) && vectorLen(%obj.getVelocity()) < 0.1)
	return getWord(normalFromRaycast(%ray), 2) $= "1";
	return false;
}

// Bipod Trigger
function Armor::onTrigger(%this, %player, %slot, %val)
{
	// Crouching Protection.
	if (%slot $= 3 && %val)
		%player.isCrouching = 1;
	else if (%slot $= 3 && !%val)
		%player.isCrouching = 0;
		
    if(%player.getMountedImage(0).RYG_Bipod == 1 && %slot $= 4 && %val)
    {
		if(%player.isBipodDeployed == 1)
		{
			removeBipod(%player);
		}
		else if(candeploy(%player.client))
		{
			%player.wasCrouching = %player.isCrouching;
			deployBipod(%player);
		}
    }
	
	if(%player.isCrouching != %player.wasCrouching && %player.isBipodDeployed == 1)
		removeBipod(%player);
	
    Parent::onTrigger(%this, %player, %slot, %val);
}

function removeBipod(%this)
{
	serverPlay3D(BiPodDequipSound,%this.getPosition());
	//%this.playsound(BiPodDequipSound);
	%this.popDatablock(NoMoveArmor.getID());
	%this.playThread(2, plant);
	%this.isBipodDeployed = 0;
    removeAllRecoil(%this.getMountedImage(0));
}

function deployBipod(%this)
{
	serverPlay3D(BiPodEquipSound,%this.getPosition());
	//%this.playsound(BiPodEquipSound);
	%this.pushDatablock(NoMoveArmor.getID());
	%this.playThread(2, shiftleft);
    removeAllRecoil(%this.getMountedImage(0));
	%this.isBipodDeployed = 1;
}

function WeaponImage::OnUnMount(%this, %obj, %slot)
{
	if(%obj.isBopodDeployed ==1)
		removeBipod(%player);
	parent::onUnMount(%this, %obj, %slot);
}

};
activatePackage(Bipods);
