// ================================================================================================================================================================================================
// Title:	Dynamic Recoil
// Version: 1.2 (NEEDS TO BE UPDATED to 2.0 (Add Projectile Support & A Toggle)
// Author(s):	Rykuta
//
// Description:	Makes weapon recoil highly dynamic, giving it properties allowing it to expand and contract based on various actions.
//		
// Disclaimer:	This add-on is the sole property of Rykuta and his subsidiaries, any illegal reproduction of this software (AKA Pretending its your own) will result in legal action.
//					By downloading this add-on you agree to the terms of service, which are as follows: You will not take credit for this add-on. You will report
//					all glitches and problems you have with the mod. You will not alter any of the code within this document without the express written consent of
//					the  Development Team. You will not re-release this add-on on RTB or any other add-on location.
//
//			That being said, this code is for adding some fancy recoil to your weapons. Please use this for its intended purpose.
//				- Rykuta
//
// ================================================================================================================================================================================================
//
// ================================================================================================================================================================================================
// Table of Contents:
// ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// Section 1:	Raycasting ............	# 35 
// Section 2:	Non-Raycasting ........	# 35 
// ================================================================================================================================================================================================
// =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
// 
// ================================================================================================================================================================================================
// Section 1:	Raycasting
// ================================================================================================================================================================================================
// NOTE: Because of the nature of raycasting weapons VS Non-raycasting, there are more functions and more manipulation available for the raycasting section then regular.
// The regular section will also require significantly more effort on the coders side of things, simply because these functions only return values, how these values are used, is up to the developer.
package RYGRecoil
{
    // Primary function, utilizes some of the non-raycasting weapon's functions. Have your weapons implement this should you need them to.
    function WeaponImage::OnFire(%this, %obj, %slot)
    {
		//echo(%obj.lastFireTime);
		//echo(getSimTime() - %obj.lastFireTime);
		//echo("---");
	    // Originally designed to also compenate for bots, But badspot killed them and instead had rotty make a ball mod.
        // ROTONDO YOU FOO, UPDATE ZOMBIES AND STOP TRYING TO DISTRACT US WITH YOUR BALLS!
	    if(%this.RYG_Support != 1 || %obj.getClassName() $= AiPlayer)
		    return Parent::onFire(%this,%obj,%slot);
	    else
		    %this.raycastDirectDamage = %this.RYG_maxDmg;

        // Spread, Tiny little function huh?			1						2						3				4					5					6						7				8					9					10					11						12						13					14				15					16
	    if ((%this.RYG_ForceRaycast == 1 || $Pref::RYG::ProjectileType != 0) && this.RYG_ForceProjectile != 1)
			%this.raycastSpreadAmt = generateSpread(%this.raycastSpreadAmt, %this.RYG_Accuracy, %this.RYG_RecoilAdd, %this.RYG_RecoilSub, %this.RYG_RecoilTick, %this.RYG_MaxRecoil, %obj.lastFireTime, %obj.lastMoved, %obj.getVelocity(), %obj.isBipodDeployed, %this.RYG_BipodPer, %this.RYG_MovementPer, %this.RYG_MoveTimeout, %obj.isCrouching, %this.RYG_CrouchPer, getSimTime());
		else
			generateProjectile(%this, %obj, %slot);
        // Final little thingies to note.
        if($Pref::RYG::ReloadingEnabled == 1)
            %obj.clipAmmo[%this]--;
        if($Pref::RYG::LimitedAmmo == 1)
            %obj.gunAmmo[%this]--;
	    displayAmmo(%obj, %this);
	    %obj.lastFireTime = getSimTime();
        if(%obj.getVelocity() > 0.1)
            %obj.lastMoved = getSimTime();
            
	    Parent::onFire(%this,%obj,%slot);
        if(%obj.clipAmmo[%this] < 0 && this.RYG_Support == 1)
			%obj.clipAmmo[%this] = 0; 
    }

    // %this is the image.
    function removeAllRecoil(%this)
    {
	    %this.raycastSpreadAmt = %this.RYG_Accuracy;	
    }

}; activatePackage(RYGRecoil);
// ================================================================================================================================================================================================
// Section 2:	Non-Raycasting
// ================================================================================================================================================================================================
// There are so many values to take into account! Good God man! 1234		5			6				7			8				9				10				11				12			13				14				15			16
function generateSpread(%currSpread, %accuracy, %recoilAdd, %recoilSub, %recoilTick, %maxRecoil, %lastFireTime, %lastMoved, %currMoveSpeed, %bipodDeployed, %bipodReduction, %maxMovePer, %noMoveTimeout, %isCrouching, %crouchReduction, %currTime)
{
    // This value represents the spread, it will be modified a lot, or not at all.
    %spread = %currSpread;
    
	// Now we do the actual calculations/changes.
	if(%lastFireTime + %recoilTick > getSimTime())
	{
		if(%bipodDeployed == 1)
			%spread += (%recoilAdd * (%bipodReduction * 0.01));
		else if(%isCrouching == 1)
            %spread += (%recoilAdd * (%crouchReduction * 0.01));
        else 
			%spread += %recoilAdd;
	}
    else    // Reduces recoil as a factor of time.
    {
        %incs = Mceil((%currTime - %lastFireTime) / %recoilTick);
        %spread -= (%incs * %recoilSub);
    }
	
    // Motion Stuff.
	if(%currMoveSpeed > 0.1)
    {
        %spread += (%recoilAdd * (%maxMovePer * 0.01));
    }
    else if(%lastMoved + %noMoveTimeout > %currTime)
    {
        // %dist is the time difference between max timeout and last moved, important for the falloff function.
        %dist = %lastMoved + %noMovetimeout - %currTime;
        %spread += (%recoilAdd * ((doFalloff(%dist, %maxMovePer, 100, 0, %lastMoved)) * 0.01)); 
    }

	// Clamp the values.
    if(%spread > %maxRecoil)
        %spread = %maxRecoil;
    else if (%spread < %accuracy)
        %spread = %accuracy;

    return %spread;
}

function generateProjectile(%this, %obj, %slot)
{
    // No reason to create another variable to store this, even though it is no longer being used for raycasts.
    %this.raycastSpreadAmt = generateSpread(%this.raycastSpreadAmt, %this.RYG_Accuracy, %this.RYG_RecoilAdd, %this.RYG_RecoilSub, %this.RYG_RecoilTick, %this.RYG_MaxRecoil, %obj.lastFireTime, %obj.lastMoved, %obj.getVelocity(), %obj.isBipodDeployed, %this.RYG_BipodPer, %this.RYG_MovementPer, %this.RYG_MoveTimeout, %obj.isCrouching, %this.RYG_CrouchPer, getSimTime());

    %projectile = %this.raycastTracerProjectile;	
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %this.raycastSpreadAmt;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %this.raycastSpreadAmt;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %this.raycastSpreadAmt;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	MissionCleanup.add(%p);
    %p.specDamageType = %this.raycastDirectDamageType; // An attempt to resolve the fact that these projectiles are being used for multiple guns so I will need to assign proper damagetypes.
	return %p;
}

























