// ================================================================================================================================================================================================
// Title:	Varaiable Damage!
// Author(s):	Rykuta
//
// Description:	Modifies a weapons base damage to deal more or less given different scenarios.
//		
// Disclaimer:	This add-on is the sole property of Rykuta and his subsidiaries, any illegal reproduction of this software (AKA Pretending its your own) will result in legal action.
//					By downloading this add-on you agree to the terms of service, which are as follows: You will not take credit for this add-on. You will report
//					all glitches and problems you have with the mod. You will not alter any of the code within this document without the express written consent of
//					the  Development Team. You will not re-release this add-on on RTB or any other add-on location.
//
//			That being said, this code is for adding varying weapon damages. Please use this for its intended purpose.
//				- Rykuta
//
// ================================================================================================================================================================================================
//
// ================================================================================================================================================================================================
// Table of Contents:
// ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// Section 1:	Variables .............	# 29 
// Section 2:	Functions .............	# 35 
// ================================================================================================================================================================================================
// =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
// 
// ================================================================================================================================================================================================
// Section 1:	Varaibles & RTB
// ================================================================================================================================================================================================
//if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
//{
//	if(!$RTB::Hooks::ServerControl)	exec("Add-Ons/System_ReturnToBlockland/hooks/serverControl.cs");
    RTB_registerPref("Damage Modification %","Ry-Guns","Pref::RYG::DamageModifier","int 1 500","Support_RyGuns",100,0,0);
    RTB_registerPref("Headshots Enabled","Ry-Guns","Pref::RYG::Headshots","bool","Support_RyGuns",1,0,0);
	RTB_registerPref("Use Raycasting Projectiles","Ry-Guns","Pref::RYG::ProjectileType","bool","Support_RyGuns",1,0,0);
    RTB_registerPref("Damage Falloff Enabled","Ry-Guns","Pref::RYG::DmgFalloff","bool","Support_RyGuns",1,0,0);
//}
//else
//{
	$Pref::RYG::ProjectileType = 1;		// Set to 1 for raycasting, set to 0 for default projectiles.
    $Pref::RYG::DamageModifier = 100;   // Controls Damage based on a default amt, alters all weapons.
    $Pref::RYG::Headshots = 1;          // Allows weapons to deal bonus head damage.
    $Pref::RYG::DmgFalloff = 1;         // Allows damage to falloff with range. (Will use max otherwise)
//}

// ================================================================================================================================================================================================
// Section 2:	Functions
// ================================================================================================================================================================================================
package RYGDamage 
{
    // Handles damage modification for raycast weapons
    function WeaponImage::onRaycastDamage(%this,%obj,%slot,%col,%pos,%normal,%shotVec,%crit)
    {
	    if(%this.RYG_Support == 1 && $Pref::RYG::DmgFalloff == 1)
		    %this.raycastDirectDamage = doFalloff(vectorDist(%obj.getPosition(), %pos), %this.RYG_MaxDmg, %this.RYG_MinDmg, %this.RYG_FalloffMax, %this.RYG_FalloffMin);
		
	    if(%col.getType() & $TypeMasks::PlayerObjectType && %this.RYG_Support == 1 && $Pref::RYG::Headshots)
	    {
		    %colscale = getWord(%col.getScale(),2);
		    if(getword(%pos, 2) > getword(%col.getWorldBoxCenter(), 2) - 3.3*%colscale && %obj.getClassName() $= Player)
		    {
			    %this.raycastDirectDamage = (%this.raycastDirectDamage * %this.RYG_Headshot);
		    }
	    }
	    if($Pref::RYG::DamageModifier > 0)
		    %this.raycastDirectDamage = %this.raycastDirectDamage * ($Pref::RYG::DamageModifier * 0.01);
	
	    Parent::onRaycastDamage(%this,%obj,%slot,%col,%pos,%normal,%shotVec,%crit);
    }

    // TODO: REGULAR WEAPON DAMAGE FUNCTION IS NEEDED HERE!

    // A function that calculates values based on mins and maxes, and a cute little line between them. If value is outside of this domain, it returns the highest or lowest values respectivly.
    // In this function %dist represents the magic value we are currently trying to get on the graph formed with the maxs and mins.
    function doFalloff(%dist, %maxVal, %minVal, %maxFalloff, %minFalloff)
    {
	    if(%dist > %minFalloff)
	    {
		    if(%dist > %maxFalloff)
			    return %minVal;
		
		    // We make a line of sorts.
		    %slope = (%maxVal - %minVal) / (%minFalloff - %maxFalloff);
		    %yInter = (%maxval - (%slope * %minFalloff));
		    return (mFloor(%slope * %dist + %yInter));
	    }
	    else
		    return %maxVal;
    }
}; activatePackage(RYGDamage);